/**
 * termynal.js
 * A lightweight, modern and extensible animated terminal window, using
 * async/await.
 *
 * @author Ines Montani <ines@ines.io>
 * @version 0.0.1
 * @license MIT
 */"use strict";class Termynal{constructor(t="#termynal",e={}){this.container=typeof t=="string"?document.querySelector(t):t,this.pfx=`data-${e.prefix||"ty"}`,this.startDelay=e.startDelay||parseFloat(this.container.getAttribute(`${this.pfx}-startDelay`))||600,this.typeDelay=e.typeDelay||parseFloat(this.container.getAttribute(`${this.pfx}-typeDelay`))||90,this.lineDelay=e.lineDelay||parseFloat(this.container.getAttribute(`${this.pfx}-lineDelay`))||1500,this.progressLength=e.progressLength||parseFloat(this.container.getAttribute(`${this.pfx}-progressLength`))||40,this.progressChar=e.progressChar||this.container.getAttribute(`${this.pfx}-progressChar`)||"\u2588",this.progressPercent=e.progressPercent||parseFloat(this.container.getAttribute(`${this.pfx}-progressPercent`))||100,this.cursor=e.cursor||this.container.getAttribute(`${this.pfx}-cursor`)||"\u258B",this.lineData=this.lineDataToElements(e.lineData||[]),e.noInit||this.init()}init(){this.lines=[...this.container.querySelectorAll(`[${this.pfx}]`)].concat(this.lineData);const t=getComputedStyle(this.container);this.container.style.width=t.width!=="0px"?t.width:void 0,this.container.style.minHeight=t.height!=="0px"?t.height:void 0,this.container.setAttribute("data-termynal",""),this.container.innerHTML="",this.start()}async start(){await this._wait(this.startDelay);for(let t of this.lines){const e=t.getAttribute(this.pfx),r=t.getAttribute(`${this.pfx}-delay`)||this.lineDelay;e=="input"?(t.setAttribute(`${this.pfx}-cursor`,this.cursor),await this.type(t),await this._wait(r)):e=="progress"?(await this.progress(t),await this._wait(r)):(this.container.appendChild(t),await this._wait(r)),t.removeAttribute(`${this.pfx}-cursor`)}}async type(t){const e=[...t.textContent],r=t.getAttribute(`${this.pfx}-typeDelay`)||this.typeDelay;t.textContent="",this.container.appendChild(t);for(let s of e)await this._wait(r),t.textContent+=s}async progress(t){const e=t.getAttribute(`${this.pfx}-progressLength`)||this.progressLength,s=(t.getAttribute(`${this.pfx}-progressChar`)||this.progressChar).repeat(e),h=t.getAttribute(`${this.pfx}-progressPercent`)||this.progressPercent;t.textContent="",this.container.appendChild(t);for(let i=1;i<s.length+1;i++){await this._wait(this.typeDelay);const a=Math.round(i/s.length*100);if(t.textContent=`${s.slice(0,i)} ${a}%`,a>h)break}}_wait(t){return new Promise(e=>setTimeout(e,t))}lineDataToElements(t){return t.map(e=>{let r=document.createElement("div");return r.innerHTML=`<span ${this._attributes(e)}>${e.value||""}</span>`,r.firstElementChild})}_attributes(t){let e="";for(let r in t)e+=this.pfx,r==="type"?e+=`="${t[r]}" `:r!=="value"&&(e+=`-${r}="${t[r]}" `);return e}}document.currentScript.hasAttribute("data-termynal-container")&&document.currentScript.getAttribute("data-termynal-container").split("|").forEach(t=>new Termynal(t));
//# sourceMappingURL=termynal.min.js.map
